# encoding: utf-8
# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file

import os
from waflib import Task,TaskGen,Options
@TaskGen.feature('javatest')
@TaskGen.after_method('apply_java','use_javac_files','set_classpath')
def make_javatest(self):
	tsk=self.create_task('utest')
	tsk.set_run_after(self.javac_task)
	if getattr(self,'jtest_source',None):
		tsk.inputs=self.to_nodes(self.jtest_source)
	else:
		if self.javac_task.srcdir[0].exists():
			tsk.inputs=self.javac_task.srcdir[0].ant_glob('**/*.java',remove=False)
	if getattr(self,'ut_str',None):
		self.ut_run,lst=Task.compile_fun(self.ut_str,shell=getattr(self,'ut_shell',False))
		tsk.vars=lst+tsk.vars
	if getattr(self,'ut_cwd',None):
		if isinstance(self.ut_cwd,str):
			if os.path.isabs(self.ut_cwd):
				self.ut_cwd=self.bld.root.make_node(self.ut_cwd)
			else:
				self.ut_cwd=self.path.make_node(self.ut_cwd)
	else:
		self.ut_cwd=self.bld.bldnode
	tsk.env.CLASSPATH=':'.join(self.env.CLASSPATH)+':'+self.outdir.abspath()
	if not self.ut_cwd.exists():
		self.ut_cwd.mkdir()
	if not hasattr(self,'ut_env'):
		self.ut_env=dict(os.environ)
def configure(ctx):
	cp=ctx.env.CLASSPATH or'.'
	if getattr(Options.options,'jtpath',None):
		ctx.env.CLASSPATH_JAVATEST=getattr(Options.options,'jtpath').split(':')
		cp+=':'+getattr(Options.options,'jtpath')
	if getattr(Options.options,'jtrunner',None):
		ctx.env.JTRUNNER=getattr(Options.options,'jtrunner')
	if ctx.check_java_class(ctx.env.JTRUNNER,with_classpath=cp):
		ctx.fatal('Could not run test class %r'%ctx.env.JTRUNNER)
def options(opt):
	opt.add_option('--jtpath',action='store',default='',dest='jtpath',help='Path to jar(s) needed for javatest execution, colon separated, if not in the system CLASSPATH')
	opt.add_option('--jtrunner',action='store',default='org.testng.TestNG',dest='jtrunner',help='Class to run javatest test [default: org.testng.TestNG]')
